#include "sagem_mso_i.h"

MSO_STATUS MSO_Exchange(BYTE *send, WORD send_len, BYTE *resp, WORD *resp_len, DWORD timeout)
{
  MSO_STATUS rc;
  BYTE r_msoID, r_msoRC;
  
  if (!sprox_external.active.p.mso)
  {
    rc = MSO_Open();
    if (rc != ILV_OK)
      return rc;
  }

  if ((send != NULL) && (send_len > 0))
  {
    msoRequestCounter++;

    rc = MSO_PP_Send(0x61, msoRequestCounter, send, send_len);
    if (rc != ILV_OK)
    {
      /* Access to the reader has been lost */
      MSO_Close();
      return rc;
    }
  }

  rc = MSO_PP_Recv(&r_msoID, &r_msoRC, resp, resp_len, timeout);
  if (rc == ILV_OK)
    return ILV_OK;

  return rc;
}
